#####################################################################
#
#       Author : Kushal Das
#       Copyright (c)  2007-2009 Kushal Das
#       kushal@fedoraproject.org
#
#####################################################################


from PyQt4 import QtCore, QtGui
from PyQt4 import uic
from PyQt4.QtGui import QFileDialog
import sys
import os
import codecs
import tempfile
from BasicTranslation import BasicTranslation

#Setup Ui
Ui_translation, throwaway = uic.loadUiType(os.path.join("/usr/share/translationfilter",'ui/translation-filterUI.ui'))
#Ui_translation, throwaway = uic.loadUiType('ui/translation-filterUI.ui')

class TranslationUI(Ui_translation, QtGui.QMainWindow, BasicTranslation):
    """My class"""
    def __init__(self):
        QtGui.QMainWindow.__init__(self)
        BasicTranslation.__init__(self)
        self.setupUi(self)
        self.connect(self.searchBttn,QtCore.SIGNAL("clicked()"),self.searchGUI)
        self.connect(self.dirBttn,QtCore.SIGNAL("clicked()"),self.getDir)
        self.connect(self.actionSave,QtCore.SIGNAL("triggered()"),self.fileSave)
        self.connect(self.action_Exit,QtCore.SIGNAL("triggered()"),self.exit)
        self.connect(self.selectBttn,QtCore.SIGNAL("clicked()"),self.getFile)
        self.connect(self.addBttn,QtCore.SIGNAL("clicked()"),self.addFile)
        self.connect(self.removeBttn,QtCore.SIGNAL("clicked()"),self.removeFile)
        self.connect(self.clearBttn,QtCore.SIGNAL("clicked()"),self.clearlist)
        filename = os.path.join(os.path.expanduser("~"), ".translation-filter")
        if os.path.isfile(filename):
            files = [x.strip() for x in open(filename).readlines()]
            for pofile in files:
                self.listbox.addItem(pofile)
            if len(files) > 0:
                self.dirBttn.setEnabled(False)

    def clearlist(self):
        """Clear the list"""
        self.listbox.clear()
        self.pofilesave()
        self.dirBttn.setEnabled(True)

    def pofilesave(self):
        """Save the po file list"""
        filename = os.path.join(os.path.expanduser("~"), ".translation-filter")
        f = open(filename,"w")
        for x in range(0,self.listbox.count()):
            f.write(str(self.listbox.item(x).text())+"\n")
        f.close()

    def addFile(self):
        """Add a file to the widget"""
        path = str(self.filepath.text())
        path = path.strip()
        if path != "":
            self.dirBttn.setEnabled(False)
            self.listbox.addItem(path)
        self.filepath.clear()
        self.pofilesave()

    def removeFile(self):
        """To remove any selected file"""
        self.listbox.takeItem(self.listbox.currentRow())
        self.pofilesave()
        if self.listbox.count() == 0:
            self.dirBttn.setEnabled(True)

    def getFile(self):
        """Code to selcect a directory"""
        path = str(QFileDialog.getOpenFileName(self, "Select File",".", "*.po"))
        self.filepath.setText(path)

    def getDir(self):
        """Code to selcect a directory"""
        self.path = str(QFileDialog.getExistingDirectory(self, "Select Directory",".", QFileDialog.ShowDirsOnly | QFileDialog.DontResolveSymlinks))

    def searchGUI(self):
        """Search function for the GUI"""
        text = str(self.lineEdit.text())
        if text == "":
            return
        self.search(text)
        self.setResult()
        return

    def config(self):
        """Open File List window"""
        win = FileListUI().showwindow()

    def setResult(self):
        """Set the result to the GUI"""
        data = codecs.open("/usr/share/translationfilter/data/index.html", encoding="UTF-8").read()
        data = data.replace("%<<Replace>>", self.html)
        fname = tempfile.mkstemp()[1]
        fname =fname+".html"
        f = codecs.open(fname, "w", encoding="UTF-8")
        f.write(data)
        f.close()
        self.resultBox.load(QtCore.QUrl("file://" + fname))

    def fileSaveAs(self):
        fn = QtGui.QFileDialog.getSaveFileName(self, "Save Searh Result as...",
                          '', "HTML files (*.html);;All Files (*)")
        if fn.isEmpty():
            return False
        self.filename = unicode(fn)
        return self.fileSave()

    def fileSave(self):
        if self.filename == '': 
            return self.fileSaveAs()
        f = codecs.open(self.filename,'w', encoding="UTF-8")
        f.write("""<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /></head><body>""")
        f.write(self.html)
        f.write("</body></html>")
        f.close()
        return True



class TranslationApp(QtGui.QApplication):
    """Main application class"""
    def __init__(self,args=None):
        QtGui.QApplication.__init__(self,args)
        self.mywindow = TranslationUI()
        self.mywindow.show()
        self.exec_()

